#pragma once

#include <dsound.h>

#define MAX_SOUND_COPIES	8

typedef struct sfxinfo_s
{
	char tagName[32];
	char lumpname[12]; // Only need 9 bytes, but padded out to be dword aligned
	//struct sfxinfo_s *link; // Make alias for another sound
	int priority; // Higher priority takes precendence
	int usefulness; // Determines when a sound should be cached out
	void *snd_ptr;
	int lumpnum;
	int numchannels; // total number of channels a sound type may occupy
	boolean	changePitch;
	IDirectSoundBuffer **rgpDSB;
} sfxinfo_t;

int I_GetSfxLumpNum(sfxinfo_t *sound);
